dojo.provide("dojo.widget.Manager");
dojo.require("dojo.lang");
dojo.require("dojo.event.*");
dojo.widget.manager=new function(){
this.widgets=[];
this.widgetIds=[];
this.topWidgets={};
var _1={};
var _2=[];
this.getUniqueId=function(_3){
return _3+"_"+(_1[_3]!=undefined?++_1[_3]:_1[_3]=0);
};
this.add=function(_4){
dojo.profile.start("dojo.widget.manager.add");
this.widgets.push(_4);
if(_4.widgetId==""){
if(_4["id"]){
_4.widgetId=_4["id"];
}else{
if(_4.extraArgs["id"]){
_4.widgetId=_4.extraArgs["id"];
}else{
_4.widgetId=this.getUniqueId(_4.widgetType);
}
}
}
if(this.widgetIds[_4.widgetId]){
dojo.debug("widget ID collision on ID: "+_4.widgetId);
}
this.widgetIds[_4.widgetId]=_4;
dojo.profile.end("dojo.widget.manager.add");
};
this.destroyAll=function(){
for(var x=this.widgets.length-1;x>=0;x--){
try{
this.widgets[x].destroy(true);
delete this.widgets[x];
}
catch(e){
}
}
};
this.remove=function(_6){
var tw=this.widgets[_6].widgetId;
delete this.widgetIds[tw];
this.widgets.splice(_6,1);
};
this.removeById=function(id){
for(var i=0;i<this.widgets.length;i++){
if(this.widgets[i].widgetId==id){
this.remove(i);
break;
}
}
};
this.getWidgetById=function(id){
return this.widgetIds[id];
};
this.getWidgetsByType=function(_b){
var lt=_b.toLowerCase();
var _d=[];
dojo.lang.forEach(this.widgets,function(x){
if(x.widgetType.toLowerCase()==lt){
_d.push(x);
}
});
return _d;
};
this.getWidgetsOfType=function(id){
dj_deprecated("getWidgetsOfType is depecrecated, use getWidgetsByType");
return dojo.widget.manager.getWidgetsByType(id);
};
this.getWidgetsByFilter=function(_10){
var ret=[];
dojo.lang.forEach(this.widgets,function(x){
if(_10(x)){
ret.push(x);
}
});
return ret;
};
this.getAllWidgets=function(){
return this.widgets.concat();
};
this.byId=this.getWidgetById;
this.byType=this.getWidgetsByType;
this.byFilter=this.getWidgetsByFilter;
var _13={};
var _14=["dojo.widget","dojo.webui.widgets"];
for(var i=0;i<_14.length;i++){
_14[_14[i]]=true;
}
this.registerWidgetPackage=function(_16){
if(!_14[_16]){
_14[_16]=true;
_14.push(_16);
}
};
this.getWidgetPackageList=function(){
return dojo.lang.map(_14,function(elt){
return (elt!==true?elt:undefined);
});
};
this.getImplementation=function(_18,_19,_1a){
var _1b=this.getImplementationName(_18);
if(_1b){
var ret=new _1b(_19);
return ret;
}
};
this.getImplementationName=function(_1d){
var _1e=_1d.toLowerCase();
var _1f=_13[_1e];
if(_1f){
return _1f;
}
if(!_2.length){
for(var _20 in dojo.render){
if(dojo.render[_20]["capable"]===true){
var _21=dojo.render[_20].prefixes;
for(var i=0;i<_21.length;i++){
_2.push(_21[i].toLowerCase());
}
}
}
_2.push("");
}
for(var i=0;i<_14.length;i++){
var _23=dojo.evalObjPath(_14[i]);
if(!_23){
continue;
}
for(var j=0;j<_2.length;j++){
if(!_23[_2[j]]){
continue;
}
for(var _25 in _23[_2[j]]){
if(_25.toLowerCase()!=_1e){
continue;
}
_13[_1e]=_23[_2[j]][_25];
return _13[_1e];
}
}
for(var j=0;j<_2.length;j++){
for(var _25 in _23){
if(_25.toLowerCase()!=(_2[j]+_1e)){
continue;
}
_13[_1e]=_23[_25];
return _13[_1e];
}
}
}
throw new Error("Could not locate \""+_1d+"\" class");
};
this.resizing=false;
this.onResized=function(){
if(this.resizing){
return;
}
try{
this.resizing=true;
for(var id in this.topWidgets){
var _27=this.topWidgets[id];
if(_27.onResized){
_27.onResized();
}
}
}
finally{
this.resizing=false;
}
};
if(typeof window!="undefined"){
dojo.addOnLoad(this,"onResized");
dojo.event.connect(window,"onresize",this,"onResized");
}
};
dojo.widget.getUniqueId=function(){
return dojo.widget.manager.getUniqueId.apply(dojo.widget.manager,arguments);
};
dojo.widget.addWidget=function(){
return dojo.widget.manager.add.apply(dojo.widget.manager,arguments);
};
dojo.widget.destroyAllWidgets=function(){
return dojo.widget.manager.destroyAll.apply(dojo.widget.manager,arguments);
};
dojo.widget.removeWidget=function(){
return dojo.widget.manager.remove.apply(dojo.widget.manager,arguments);
};
dojo.widget.removeWidgetById=function(){
return dojo.widget.manager.removeById.apply(dojo.widget.manager,arguments);
};
dojo.widget.getWidgetById=function(){
return dojo.widget.manager.getWidgetById.apply(dojo.widget.manager,arguments);
};
dojo.widget.getWidgetsByType=function(){
return dojo.widget.manager.getWidgetsByType.apply(dojo.widget.manager,arguments);
};
dojo.widget.getWidgetsByFilter=function(){
return dojo.widget.manager.getWidgetsByFilter.apply(dojo.widget.manager,arguments);
};
dojo.widget.byId=function(){
return dojo.widget.manager.getWidgetById.apply(dojo.widget.manager,arguments);
};
dojo.widget.byType=function(){
return dojo.widget.manager.getWidgetsByType.apply(dojo.widget.manager,arguments);
};
dojo.widget.byFilter=function(){
return dojo.widget.manager.getWidgetsByFilter.apply(dojo.widget.manager,arguments);
};
dojo.widget.all=function(n){
var _29=dojo.widget.manager.getAllWidgets.apply(dojo.widget.manager,arguments);
if(arguments.length>0){
return _29[n];
}
return _29;
};
dojo.widget.registerWidgetPackage=function(){
return dojo.widget.manager.registerWidgetPackage.apply(dojo.widget.manager,arguments);
};
dojo.widget.getWidgetImplementation=function(){
return dojo.widget.manager.getImplementation.apply(dojo.widget.manager,arguments);
};
dojo.widget.getWidgetImplementationName=function(){
return dojo.widget.manager.getImplementationName.apply(dojo.widget.manager,arguments);
};
dojo.widget.widgets=dojo.widget.manager.widgets;
dojo.widget.widgetIds=dojo.widget.manager.widgetIds;
dojo.widget.root=dojo.widget.manager.root;

